﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;

namespace Demo01
{
    class Program
    {
        static void Main(string[] args)
        {
            using(WorkflowRuntime workflowRuntime = new WorkflowRuntime())
            {
                AutoResetEvent waitHandle = new AutoResetEvent(false);
                workflowRuntime.WorkflowCompleted += delegate(object sender, WorkflowCompletedEventArgs e) {waitHandle.Set();};
                workflowRuntime.WorkflowTerminated += delegate(object sender, WorkflowTerminatedEventArgs e)
                {
                    Console.WriteLine(e.Exception.Message);
                    waitHandle.Set();
                };
                Dictionary<string, object> parameters = new Dictionary<string, object>();
                parameters.Add("MaxVoltLevel",30000);

                List<RouteItem> routeTable = new List<RouteItem>();
                routeTable.Add(new RouteItem("Power A", 10000));
                routeTable.Add(new RouteItem("Power B", 20000));
                parameters.Add("RouteTable", routeTable);

                WorkflowInstance instance = workflowRuntime.CreateWorkflow(typeof(Demo01.ControllingFlows),parameters);
                instance.Start();

                waitHandle.WaitOne();
            }
        }
    }
}
