﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;
using System.Workflow.Activities;

namespace Demo05
{
    class Program
    {
        static void Main(string[] args)
        {
            using(WorkflowRuntime workflowRuntime = new WorkflowRuntime())
            {
                ExternalDataExchangeService service = new ExternalDataExchangeService();
                workflowRuntime.AddService(service);

                DocumentMetadata myDocument = new DocumentMetadata();
                service.AddService(myDocument);

                AutoResetEvent waitHandle = new AutoResetEvent(false);
                workflowRuntime.WorkflowCompleted += delegate(object sender, WorkflowCompletedEventArgs e) {waitHandle.Set();};
                workflowRuntime.WorkflowTerminated += delegate(object sender, WorkflowTerminatedEventArgs e)
                {
                    Console.WriteLine(e.Exception.Message);
                    waitHandle.Set();
                };

                WorkflowInstance instance = workflowRuntime.CreateWorkflow(typeof(Demo05.Workflow1));
                instance.Start();

                Console.WriteLine("Press Enter Key");
                Console.ReadLine();
                myDocument.FireFixed(instance.InstanceId);


                Console.WriteLine("Press Enter Key");
                Console.ReadLine();
                myDocument.FireFixed(instance.InstanceId);

                Console.WriteLine("Press Enter Key");
                Console.ReadLine();
                myDocument.FireArchive(instance.InstanceId);

                waitHandle.WaitOne();
            }
        }
    }
}
